MinCostArborescenceDefaultTraits< GR, CM > Struct Template Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members | Public Types | Static Public Member Functions
MinCostArborescenceDefaultTraits< GR, CM > Struct Template Reference

## Detailed Description

### template<class GR, class CM>
struct lemon::MinCostArborescenceDefaultTraits< GR, CM >

Default traits class for MinCostArborescence class.

Parameters

  GR | Digraph type.
  CM | Type of the cost map.

`#include <lemon/min_cost_arborescence.h>`

## Public Types
typedef GR | Digraph
| The digraph type the algorithm runs on.
typedef CM | CostMap
| The type of the map that stores the arc costs. More...
typedef CostMap::Value | Value
| The value type of the costs. More...
typedef Digraph::template ArcMap< bool > | ArborescenceMap
| The type of the map that stores which arcs are in the arborescence. More...
typedef Digraph::template NodeMap< typename Digraph::Arc > | PredMap
| The type of the `PredMap`. More...

## Static Public Member Functions
static ArborescenceMap * | createArborescenceMap (const Digraph &digraph)
| Instantiates a `ArborescenceMap`. More...
static PredMap * | createPredMap (const Digraph &digraph)
| Instantiates a `PredMap`. More...

## Member Typedef Documentation

typedef CM CostMap

The type of the map that stores the arc costs. It must conform to the ReadMap concept.

typedef CostMap::Value Value

The value type of the costs.

typedef Digraph::template ArcMap<bool> ArborescenceMap

The type of the map that stores which arcs are in the arborescence. It must conform to the WriteMap concept, and its value type must be `bool` (or convertible). Initially it will be set to `false` on each arc, then it will be set on each arborescence arc once.

typedef Digraph::template NodeMap<typename Digraph::Arc> PredMap

The type of the `PredMap`. It must confrom to the WriteMap concept, and its value type must be the `Arc` type of the digraph.

## Member Function Documentation

static ArborescenceMap* createArborescenceMap | ( | const Digraph & | digraph | ) |
| inlinestatic

This function instantiates a `ArborescenceMap`.

Parameters

  digraph | The digraph to which we would like to calculate the `ArborescenceMap`.

static PredMap* createPredMap | ( | const Digraph & | digraph | ) |
| inlinestatic

This function instantiates a `PredMap`.

Parameters

  digraph | The digraph to which we would like to define the `PredMap`.